#ifndef __FKUT_OBB__
#define __FKUT_OBB__

#include <FK/FK.h>
#include <set>

class fkut_OBB {
private:
	static set<fkut_OBB *>	instanceList;
	map<fkut_OBB *, int>	nearestArray;
protected:
	fk_Vector	m_Pos;					// ʒu
	fk_Vector	m_NormaDirect[3];		// xNg
	double		m_fLength[3], sphRad;	// e̒ł̊荞ݗpa

	fk_Model	*ref_model;

	fk_Vector	backVec[15];			// 15{

	double		elemD;

	double		LenSegOnSeparateAxis(fk_Vector *Sep, fk_Vector *e1, fk_Vector *e2, fk_Vector *e3 = NULL);

	fk_Vector	GetDirect(int axis);	// w莲ԍ̕xNg擾
	double		GetLen_W(int axis);     // w莲̒擾
	fk_Vector	GetPos_W(void);         // ʒu擾

	bool		Update(void);

public:
	fkut_OBB(void);
	~fkut_OBB(void);

	void		setDivDist(double);						// ̔莞̐xݒ(ƌd)
	void		setBlockSize(double, double, double);	// TCYݒ
	void		setModel(fk_Model *);					// ʒuApAXP[̃x[XƂȂ郂f̃Zbg

	fk_Vector	checkVSPoint(fk_Vector pos);			// _Ƃ̔iʎgȂj

				// ̂Ƃ̔iWAaA߂xNg󂯁j
	bool		checkVSSphere(const fk_Vector &pos, double rad, fk_Vector &backV);
				// ̂Ƃ̔iWAaÄړxNgA߂xNg󂯁j
	bool		checkVSMovingSphere(const fk_Vector &pos, double rad, const fk_Vector &spd, fk_Vector &backV);
				// OBBm̔iOBBA߂xNg󂯁j
	bool		checkVSOBB(fkut_OBB &other, fk_Vector &backV);
				// OBBƂ̔iOBBAOBB̈ړxNgA߂xNg󂯁j
	bool		checkVSMovingOBB(fkut_OBB &other, fk_Vector &spd, fk_Vector &backV);
};

class fkut_Capsule {
private:
	fk_Vector	p, q;
	double		r, len;

	fk_Model	*ref_model;

	bool		Update(void);

public:
	void setCapsuleSize(double, double);	// JvZ̃TCYiaAj
	void setModel(fk_Model *);				// ʒuAp̃x[XƂȂ郂f̃Zbg
	// ref_model̒SWpAp+f̌(getVec()œxNg)*lenqƂ

	// JvZm̔ĩJvZA߂xNg󂯁j
	bool checkVSCapsule(fkut_Capsule &other, fk_Vector *revVec);
};

#endif
